{
2021-02-15

Ѷ TC3-HMAC-SHA256 ɼȨ
}

unit TC3_Authorization;

interface

uses
  System.SysUtils, System.hash, System.NetEncoding, System.DateUtils;

{ -------------------------------------------------------------------------------
  :    genTC3Auth
  :      
  :      2021.02.15
  :      SecretKey, SecretId, sDomain, bodyJSON, Service: string
  ˵ AccessKeyIDAccessKeySecret, ͵JSON ocr,cvm
  ֵ:    string

    SecretKey := '2rWx9i1JZ***************FMw';
    SecretId := 'AKIDFm****************9wMEAH';
    Service := 'sms'
    sDomain := 'sms.tencentcloudapi.com'

  ------------------------------------------------------------------------------- }
function genTC3Auth(SecretKey, SecretId, sDomain, bodyJSON, Service: string): string;

implementation


function DateTimeToUnix(const AValue: TDateTime): Int64;
// תUnixʱ
begin
  Result := System.DateUtils.DateTimeToUnix(AValue) - 8 * 60 * 60;
end;

//ѶTC3 V3ǩȨ
function genTC3Auth(SecretKey, SecretId, sDomain, bodyJSON, Service: string): string;
var
  httpRequestMethod: string; // = "POST";
  canonicalUri: string; //= "/";
  canonicalQueryString: string; //= "";
  canonicalHeaders: string; // = "content-type:application/json; charset=utf-8\n" + "host:" + host + "\n";
  signedHeaders: string; //= "content-type;host";
  SecretDate, SecretService, SecretSigning, Signature: TBytes;
  StringToSign, payload, CanonicalRequest, HashedRequestPayload, HashedCanonicalRequest: string;
  sDate,timestamp : string;
  Authorization, CredentialScope : string;
begin
  sDate := FormatDateTime('YYYY-MM-DD', now());
  timestamp := DateTimeToUnix(now).ToString;
  httpRequestMethod := 'POST';
  canonicalUri := '/';
  canonicalQueryString := '';
  canonicalHeaders := 'content-type:application/json' + #10
      + 'host:' + sDomain + #10;
  signedHeaders := 'content-type;host';

  payload := bodyJSON;
  //͵ݵĹϣֵ:
  HashedRequestPayload := THashSHA2.GetHashString(payload);

  //ƴӹ淶
  CanonicalRequest := httpRequestMethod + #10
      + canonicalUri + #10
      + canonicalQueryString + #10
      + canonicalHeaders + #10
      + signedHeaders + #10
      + HashedRequestPayload;

  //ǩԿ
  SecretDate := THashSHA2.GetHMACAsBytes(sDate, TEncoding.utf8.GetBytes('TC3' + SecretKey));
  SecretService := THashSHA2.GetHMACAsBytes(Service, SecretDate);
  SecretSigning := THashSHA2.GetHMACAsBytes('tc3_request', SecretService);

  //淶󴮵Ĺϣֵ
  HashedCanonicalRequest := THashSHA2.GetHashString(CanonicalRequest);
  //װǩַ
  StringToSign := 'TC3-HMAC-SHA256' + #10
      + timestamp + #10
      + sDate + '/' + Service + '/tc3_request' + #10
      + HashedCanonicalRequest;
  //ǩ
  Signature := THashSHA2.GetHMACAsBytes(Bytesof(StringToSign), SecretSigning);
//  Application.MessageBox(PChar(THash.DigestAsString(Signature)),
//      'ʾ', MB_OK + MB_ICONINFORMATION + MB_TOPMOST);

  CredentialScope := sDate + '/' + Service + '/tc3_request';
  //ƴ Authorization
  Authorization :=
    'TC3-HMAC-SHA256' + ' ' +
    'Credential=' + SecretId + '/' + CredentialScope + ', ' +
    'SignedHeaders=' + SignedHeaders + ', ' +
    'Signature=' + StringReplace(PChar(THash.DigestAsString(Signature)), Chr(13) + Chr(10), '',
    [rfReplaceAll]);

  Result := Authorization;
end;

end.
